#include <ntddk.h>

void DriverUnload(PDRIVER_OBJECT driver)
{
       DbgPrint("Driver exit\n");
       return;
}

RTL_QUERY_REGISTRY_TABLE table[2];

NTSTATUS DriverEntry(PDRIVER_OBJECT driver, PUNICODE_STRING registry)
{
	char message[20] = "def";	
	WCHAR keyname[20] = L"a";
	CHAR def[20] = "default";
	WCHAR path[100] = L"\\Registry\\Machine\\SYSTEM\\CurrentControlSet\\Services\\hello\\Parameters";
	WCHAR buffer[100];
	NTSTATUS status;
	UNICODE_STRING answer;
	DbgPrint("Driver entry\n");
	
	
	RtlZeroMemory(&table, 2 * sizeof(RTL_QUERY_REGISTRY_TABLE));

	table[0].QueryRoutine = NULL;
	table[0].Name = keyname;
	table[0].Flags = RTL_QUERY_REGISTRY_DIRECT;	
	table[0].EntryContext = buffer;
	table[0].DefaultType = REG_SZ;
	table[0].DefaultData = def;
	table[0].DefaultLength = strlen(def) + 1;
	
	// second table must have special NULL values
	table[1].QueryRoutine = NULL;
	table[1].Name = NULL;
	
	
	status =  RtlQueryRegistryValues(
		RTL_REGISTRY_ABSOLUTE,
		path,
		table,
		NULL,
		NULL);
		
	switch(status)
	{
	case STATUS_SUCCESS:
		DbgPrint("Found the value!");
		break;
	case STATUS_OBJECT_NAME_NOT_FOUND:
		DbgPrint("Object not found");
		break;
	case STATUS_INVALID_PARAMETER:
		DbgPrint("Invalid Parameter");
		break;
	case STATUS_BUFFER_TOO_SMALL:
		DbgPrint("Buffer too small");
		break;
	default:
		DbgPrint("why?...");
		break;
	}
	DbgPrint("value is %wZ\n",buffer);
		
	//RtlFreeUnicodeString(&answer);
	driver->DriverUnload = DriverUnload;
    return STATUS_SUCCESS;  
}
